import sys
from PyQt4.QtGui import QApplication
from vision import NaoVision
from vision import ColorTracker
from naoqi import ALProxy
from threading import Thread
from time import sleep


sensor = None
#IP = "127.0.0.1"  # Replace here with your NaoQi's IP address.
IP = "192.168.1.129"
PORT = 9559
CameraID = 0

sensor = ALProxy("ALSensors", IP, PORT)
sensor.subscribe("sensor")
memory = ALProxy("ALMemory", IP, PORT)
ct = None
hsvImage = None
Radius1 = 110
Radius2 = 60

def f1():
    app = QApplication(sys.argv)
    global vision
    vision = NaoVision.NaoVision(IP, PORT, CameraID)
    vision._imgWidget.showCalibrationCircle(Radius1)
    #vision._imgWidget.showGrid()
    vision.displayCamera()
        
    global sensor
    
    sensor.run()
         
    sys.exit(app.exec_())
    
    
def f2():
    ct = ColorTracker.ColorTracker()
    counter = 0
    photo1 = None
    photo2 = None
    photo3 = None
    while True:
        if memory.getData("Device/SubDeviceList/Head/Touch/Front/Sensor/Value") > 0:
            image = vision.getFrame()
            hsvImage = ct.toHSV(image)
            image.save("../../images/calibration%01d.png"%(counter), "PNG")
            if counter == 1:
                photo1 = ct.meanColorCirumference(hsvImage, Radius2, 10)
                #print photo1
                counter = counter + 1
            if counter == 0:
                photo2 = ct.meanColorCirumference(hsvImage, Radius1, 10)
                #print photo2
                vision._imgWidget.showCalibrationCircle(Radius2)
                counter = counter + 1
        if memory.getData("Device/SubDeviceList/Head/Touch/Rear/Sensor/Value") > 0:
            vision._imgWidget.showCalibrationCircle(Radius2)
            sleep(8)
            image = vision.getFrame()
            hsvImage = ct.toHSV(image)
            image.save("../../images/longshot.png", "PNG")
            vision._imgWidget.showCalibrationCircle(Radius1)
            photo3 = ct.meanColorCirumference(hsvImage, Radius2, 10)
            range = ct.getRange(photo3,4)
            print range
        if memory.getData("Device/SubDeviceList/Head/Touch/Middle/Sensor/Value") > 0:
            break
    
    #ct.getRange(photo1)


if __name__ == '__main__': 
    try:
        t1 = Thread(target=f1)
        t2 = Thread(target=f2)
        t1.start()
        t2.start()
    
    except BaseException, err:
        print err