from behaviours import lside,ltop,rside,rtop
from threading import Thread
from time import sleep
from core.nao_motion import naoMotion

from naoqi import ALProxy

import sys
from PyQt4.QtGui import QApplication
from core.nao_vision import naoVision

global memory

CameraID = 1

#IP = "127.0.0.1"  # Replace here with your NaoQi's IP address.
IP = "192.168.1.130"
PORT = 9559

motion = naoMotion(IP, PORT)

def f1():
    memory = ALProxy("ALMemory", IP, PORT)
    while True:
        if memory.getData("Device/SubDeviceList/Head/Touch/Front/Sensor/Value") > 0:
            motion.stepRight()
        if memory.getData("Device/SubDeviceList/Head/Touch/Rear/Sensor/Value") > 0:
            motion.stepLeft()
        if memory.getData("Device/SubDeviceList/Head/Touch/Middle/Sensor/Value") > 0:
            print "my head!"
            picture = vision.getPicture()
            centroid = vision.getCentroid(picture, 165, 175)
            print centroid
    
def f2():
    memory = ALProxy("ALMemory", IP, PORT)
    
    motion.loadMotion()
    motion.loadPosture()
    
    motion.setStiffnesses("Body", 1, 2)

    motion.goToPosture("Stand", 1)
        
    sleep(2)
    #motion.setWalkTargetVelocity(0.7, 0.7, 0.7, 1)
    #motion.stopMove()
    

    #motion.headPitchDownwards()
    
    #lside.main(IP, PORT)

    

def f3():
    app = QApplication(sys.argv)
    global vision
    vision = naoVision(IP, PORT, CameraID)

    #vision._imgWidget.showGrid()
    #vision._imgWidget.showCalibrationCircle(120)
    #vision.displayCamera()
        
    #sys.exit(app.exec_())

    
def f4():
    sleep(2)
    vision._imgWidget.filter(165, 175)


if __name__ == '__main__':
    try:
        t1 = Thread(target=f1)
        t2 = Thread(target=f2)
        t3 = Thread(target=f3) 
        t4 = Thread(target=f4)

        t1.start()
        t2.start()
        t3.start()
        t4.start()

    
    except BaseException, err:
        print err