import threading, time, sys, os
from threading import Thread
from time import sleep
from core.nao_motion import naoMotion

from naoqi import ALProxy

import math

global memory, ax, axR, axC, ay, record, oldX, oldY, timer, stop, counter

timer = 0.01

record = False
stop = False
ax = 0 
axR = 0
axC = 0
ay = 0 
counter = 0
maxX = 0
#IP = "127.0.0.1"  # Replace here with your NaoQi's IP address.
IP = "192.168.1.129"
PORT = 9559

motion = naoMotion(IP, PORT)
memory = ALProxy("ALMemory", IP, PORT)


def f1():
    global memory
    while True:
        if memory.getData("Device/SubDeviceList/Head/Touch/Front/Sensor/Value") > 0:
            motion.turnRight()
        if memory.getData("Device/SubDeviceList/Head/Touch/Rear/Sensor/Value") > 0:
            motion.turnLeft()
        if memory.getData("Device/SubDeviceList/Head/Touch/Middle/Sensor/Value") > 0:
            motion.moveXSquare(0.65, 0.5)

    
def f2():
    global ax, axC, ay, record, timer, stop
    memory = ALProxy("ALMemory", IP, PORT)
    
    motion.loadMotion()
    motion.loadPosture()

    #motion.goToPosture("StandInit", 1)
    
    motion.setStiffnesses("Body", 1.0)
            
    sleep(4)
    #motion.setWalkTargetVelocity(0.7, 0.7, 0.7, 1)
    #motion.stopMove()
    print "start"
    record = True
    miliseconds = time.time()
    #motion.moveXSquare(1)
    #motion.turnRight()
    motion.turnLeft()
    #motion.moveXSquare(1)
    #motion.turnRight()

    miliseconds = abs(miliseconds - time.time()) 
    print miliseconds, " ", counter
    print ax / counter, " ", ax / counter * miliseconds," ",  toDegrees(ax / counter * miliseconds), toDegrees(ax / counter * miliseconds) * 1.25
    print ay / counter, " ", ay / counter * miliseconds, " ", toDegrees(ay / counter * miliseconds)
    print axC, " ", toDegrees(axC), " ",toDegrees(axR), " ", (toDegrees(axC) + toDegrees(ax / counter * miliseconds)) /2
    print ( abs(toDegrees(axR)) + toDegrees(ax / counter * miliseconds) * 1.25 ) / 2
    #motion.turnLeft()
    #motion.turnLeft()
    #sleep(1)
    """print "end"
    stop = True
    ax = toDegrees(ax) * 1000
    axC = toDegrees(axC) * 1000
    print "ax: ", ax ," axR: ", axR, " axC", axC
    print "mix", abs(ax) + abs(axC) , "aproximation", axC*3.5 """
    os._exit(1)

def printValues(frequency):
    while(True):
        x1 = memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeX/Sensor/Value")   #rad.s-1
        y1 = memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeY/Sensor/Value")
        xC1 = memory.getData("Device/SubDeviceList/InertialSensor/AngleX/Sensor/Value")
        yC1 = memory.getData("Device/SubDeviceList/InertialSensor/AngleX/Sensor/Value")
        print x1, " ", y1, "------", #cC 
        sleep(frequency)

def toDegrees(value):
    return value * 180 / math.pi

def complementaryFilter(angle, gyrData, dt, accData):
    return 0.98 * (angle + gyrData * dt) + 0.02 * (accData)
    
def f3():
    global ax, ay, record, oldX, oldY, memory
    sleep(3)
    compute()
    """while(True):
        x = round(memory.getData("Device/SubDeviceList/InertialSensor/AngleX/Sensor/Value"), 4)
        y = round(memory.getData("Device/SubDeviceList/InertialSensor/AngleY/Sensor/Value"), 4)
        if record:
            if x != oldX:
                ax += x
            if y != oldY:
                ay += y
        oldX = x
        oldY = y
        #print "X: %02f"%memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeX/Sensor/Value")
        #print "Y: %02f"%memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeY/Sensor/Value")
        #print "Z: %02f"%memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeZ/Sensor/Value")
        #print "X: %02f"%memory.getData("Device/SubDeviceList/InertialSensor/AngleX/Sensor/Value"),"   Y: %02f"%memory.getData("Device/SubDeviceList/InertialSensor/AngleY/Sensor/Value")
        #print "X: ", x," Y: ", y
    """
def compute():
    global ax, axR, axC, ay, record, memory, stop, counter, maxX
    roundDigits = 10
    #xR = round(memory.getData("Device/SubDeviceList/InertialSensor/GyrX/Sensor/Value"), roundDigits)        #raw data
    #
    x = memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeX/Sensor/Value")   #rad.s-1
    y = memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeY/Sensor/Value")
    xC = round(memory.getData("Device/SubDeviceList/InertialSensor/AngleX/Sensor/Value"), roundDigits)      #rads
    #yy = round(memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeY/Sensor/Value"), 4)
    if record:
        ax += abs(x)
        ay += abs(y)
        axC += abs(xC)
        axR += xC
        counter += 1
        if maxX < abs(x):
            maxX = abs(x)
            
        #maxAX = 
        #maxAY = 
         #* timer
        #axR += xR #* timer
        #axC += abs(xC) #* timer
        
        #ay += y * timer
    #print "x: ", x, " xC:", xC, "  ", int(round(time.time() * 1000))
    #print x, " ", y, "\n"
    if not stop:
        threading.Timer(timer, compute).start()

def angle(x1, y1, x2, y2):
    dy = y2 - y1
    dx = math.cos(y1*(x2 - x1))
    return math.atan2(dy, dx)
        
if __name__ == '__main__':
    try:
        t1 = Thread(target=f1)
        t2 = Thread(target=f2)
        t3 = Thread(target=f3) 
        
        #t1.start()
        t2.start()
        t3.start()

    
    except BaseException, err:
        print err