import sys
from PyQt4.QtGui import QApplication
from core.nao_vision import naoVision
from threading import Thread
import threading
from time import sleep
from core.nao_motion import naoMotion

from naoqi import ALProxy

global memory 

t4_stop = None
sensor = None
#IP = "127.0.0.1"  # Replace here with your NaoQi's IP address.
IP = "192.168.1.129"
PORT = 9559
CameraID = 1


vision = None
hsvImage = None
Radius1 = 110
Radius2 = 60

def f1():
    """
    app = QApplication(sys.argv)
    global vision
    vision = naoVision(IP, PORT, CameraID)

    #vision._imgWidget.showGrid()
    vision.displayCamera()
        
    sys.exit(app.exec_())
    """
def f2():
    """
    sleep(2)
    vision._imgWidget.filter(175, 15)
    """
    
def onDeviation(self, *_args):
    #memory.unsubscribeToEvent("FaceDetected","HumanGreeter")
    print _args
    
def f3():
    memory = ALProxy("ALMemory", IP, PORT)
    
    dev = ALProxy("ALVisualCompass", IP, PORT)
    dev.enableReferenceRefresh(False)
    dev.setResolution(1)
    
    
    
    motion = naoMotion(IP, PORT)
    motion.loadMotion()
    motion.loadNavigation()
    motion.loadPosture()
    
    motion.setStiffnesses("Body", 1.0)
    
    motion.goToPosture("StandInit", 0.7)
        
    sleep(2)
    dev.subscribe("Test")
    memory.subscribeToEvent("Deviation", "Rofl", "onDeviation")
    
    dev.getReferenceImage()
    
    #motion.moveXSquare(1)
    motion.setWalkTargetVelocity(0.7, 0, 0.05, 1)
    sleep(8)
    motion.stopMove()
    
    
    #motion.goToPosture("StandInit", 0.7)
    deviation = memory.getData("VisualCompass/Deviation")
    
    wy = deviation[0][0]
    wz = deviation[0][1]
    wz = wz * 180 / 3.14
    wy = wy * 180 / 3.14
    
    #print wz
    #print wy
    #print deviation    
    
    z = 1
    y = 1
    
    print deviation[0][1], deviation[0][0]
    while(True):
        if abs(deviation[0][1]) < 0.02:#X
            z = 0
        if abs(deviation[0][0]) < 0.2:#Y
            y = 0
        motion.moveTo(0, y*1*deviation[0][0], z*-1*deviation[0][1])
        y = 0
        if z == 0 and y == 0:
            break
        
        deviation = memory.getData("VisualCompass/Deviation")
        print deviation[0][1], deviation[0][0]
        
    #motion.moveTo(0, 0, wz)
    
    dev.unsubscribe("Test")
    memory.unsubscribeToEvent("Deviation", "Rofl")
    #t4_stop.set()
    
    
    #motion._motionProxy.move(0.5, 0, 0.3)
    #sleep(6.7)
    #motion.stopMove()
      
    #motion._motionProxy.setFootSteps("RLeg", [0.0, 0.0, 0.1], 0.6, False)
    
    #motion.moveTo(1,0,0.8)
    #sleep(5)
    
    #motion._motionProxy.openHand('LHand')
    #motion._motionProxy.openHand('RHand')

    #motion._navigationProxy.setSecurityDistance(0.2)
    #motion._navigationProxy.moveTo(1,0,0)

def f4(arg1, stop_event):
    sleep(3)
    memory = ALProxy("ALMemory", IP, PORT)
    while(not stop_event.is_set()):
        print "X: %02f"%memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeX/Sensor/Value")
        print "Y: %02f"%memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeY/Sensor/Value")
        print "Z: %02f"%memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeZ/Sensor/Value")
        stop_event.wait(0.2)    

if __name__ == '__main__':
    try:
        #t1 = Thread(target=f1)
        #t2 = Thread(target=f2)
        t3 = Thread(target=f3) 
        #t4_stop = threading.Event()
        #t4 = Thread(target=f4, args=(1, t4_stop))
        #t1.start()
        #t2.start()
        t3.start()
        #t4.start()
    
    except BaseException, err:
        print err