import sys
from PyQt4.QtGui import QApplication
from core.nao_vision import naoVision
from threading import Thread
import threading
from time import sleep
from core.nao_motion import naoMotion

from naoqi import ALProxy

global memory 

t4_stop = None
sensor = None
IP = "127.0.0.1"  
#IP = "192.168.1.129"
PORT = 9559
CameraID = 1


vision = None
hsvImage = None
Radius1 = 110
Radius2 = 60

def f1():
    app = QApplication(sys.argv)
    global vision
    vision = naoVision(IP, PORT, CameraID)

    #vision._imgWidget.showGrid()
    #vision.displayCamera()
        
    sys.exit(app.exec_())
def f2():
    sleep(2)
    #vision._imgWidget.filter(175, 15)
    
def onDeviation(self, *_args):
    #memory.unsubscribeToEvent("FaceDetected","HumanGreeter")
    print _args
    
def f3():
    memory = ALProxy("ALMemory", IP, PORT)
        
    motion = naoMotion(IP, PORT)
    motion.loadMotion()
    motion.loadNavigation()
    motion.loadPosture()
    
    motion.setStiffnesses("Body", 1.0)
    
    motion.goToPosture("StandInit", 0.7)
            
    sleep(1)
    motion.moveXSquare(1)
    

def f4():
    sleep(1.7)
    memory = ALProxy("ALMemory", IP, PORT)
    while(True):
        """Device/SubDeviceList/InertialSensor/AngleX/Sensor/Value
        Device/SubDeviceList/InertialSensor/AngleY/Sensor/Value
        Theses are direct rotations values in rad.s-1."""
        GyrX = memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeX/Sensor/Value")
        GyrY = memory.getData("Device/SubDeviceList/InertialSensor/GyroscopeY/Sensor/Value")
        """Theses are direct acceleration values in m.s-2 (one g is approximately 9.81 m.s-2)."""
        AccX = - 0.009 + memory.getData("Device/SubDeviceList/InertialSensor/AccelerometerX/Sensor/Value")
        AccY = - 0.003 + memory.getData("Device/SubDeviceList/InertialSensor/AccelerometerY/Sensor/Value")
        AccZ = 9.8 + memory.getData("Device/SubDeviceList/InertialSensor/AccelerometerZ/Sensor/Value")
        
        print ("Gyrometers value X: %.3f, Y: %.3f. Accelerometers value X: %.3f, Y: %.3f, Z: %.3f" % (GyrX, GyrY, AccX, AccY, AccZ))
        sleep(0.1)

        
if __name__ == '__main__':
    try:
        #t1 = Thread(target=f1)
        #t2 = Thread(target=f2)
        t3 = Thread(target=f3) 
        t4 = Thread(target=f4)
        #t1.start()
        #t2.start()
        t3.start()
        t4.start()
    
    except BaseException, err:
        print err